#include "ChainBitmap.h"

#define BLOCK_SIZE	40

ChainBitmap::ChainBitmap()
	:width(0),height(0),count(0),lastheight(0),point(NULL)
{
}

ChainBitmap::ChainBitmap(int width, int height, const unsigned char* bits)
	:width(width),height(height),point(NULL)
{
	int i,shiftSize=(width>>3)*BLOCK_SIZE;
	count=height/BLOCK_SIZE;
	lastheight=height%BLOCK_SIZE;
	if (lastheight==0)
		lastheight=BLOCK_SIZE;
	else
		count++;
	point=new HBITMAP[count];
	for(i=0; i<(count-1); i++)
		point[i]=CreateBitmap(width,BLOCK_SIZE,1,1,bits+shiftSize*i);
	point[i]=CreateBitmap(width,lastheight,1,1,bits+shiftSize*i);
}

ChainBitmap::~ChainBitmap()
{
	if (point)
	{
		for(int i=0; i<count; i++)
			DeleteObject(point[i]);
		delete [] point;
	}
}

void ChainBitmap::setBitmap(int width, int height, const unsigned char* bits)
{
	int i;
	if (point)
	{
		for(i=0; i<count; i++)
			DeleteObject(point[i]);
		delete [] point;
		point=NULL;
	}
	this->width=width;
	this->height=height;
	int shiftSize=(width>>3)*BLOCK_SIZE;
	count=height/BLOCK_SIZE;
	lastheight=height%BLOCK_SIZE;
	if (lastheight==0)
		lastheight=BLOCK_SIZE;
	else
		count++;
	point=new HBITMAP[count];
	for(i=0; i<(count-1); i++)
		point[i]=CreateBitmap(width,BLOCK_SIZE,1,1,bits+shiftSize*i);
	point[i]=CreateBitmap(width,lastheight,1,1,bits+shiftSize*i);
}

HBITMAP ChainBitmap::operator[](int num)
{
	return point[num];
}

HBITMAP ChainBitmap::getBitmap(int num)
{
	return point[num];
}


int ChainBitmap::getWidth()
{
	return width;
}

int ChainBitmap::getHeight(int num)
{
	if (num==count-1)
		return lastheight;
	else
		return BLOCK_SIZE;
}

int ChainBitmap::getCount()
{
	return count;
}