#include <windows.h>
#include <windowsx.h>
#include "resource.h"
#include "MainDialog.h"

HINSTANCE g_hinst;
MainDialog* dialog;

BOOL CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	g_hinst=hInstance;
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_MAINDIALOG), NULL, (DLGPROC)DlgProc);
	return (FALSE);
}

BOOL CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    LPMEASUREITEMSTRUCT lpmis; 
    LPDRAWITEMSTRUCT lpdis; 

	HBITMAP hbmpPicture, hbmpOld; 
	HDC hdcMem;
	RECT rcBitmap; 

	switch(uMsg)
	{
		case WM_INITDIALOG:
			dialog=new MainDialog(g_hinst,hDlg);
			break;
		case WM_CLOSE:
			if (dialog->exit())
			{
				delete dialog;
				EndDialog(hDlg,TRUE);
			}
			break;
		case WM_DESTROY:
			break;
        case WM_MEASUREITEM: 
			lpmis = (LPMEASUREITEMSTRUCT) lParam; 
			if (lpmis->CtlID==IDC_LIST1)
				lpmis->itemHeight = 20; 
			else
				lpmis->itemHeight = dialog->getHeight(lpmis->itemID);
			break;
        case WM_DRAWITEM: 
            lpdis = (LPDRAWITEMSTRUCT) lParam; 
            if (lpdis->itemID == -1) 
            { 
                break; 
            } 
            switch (lpdis->itemAction) 
            { 
                case ODA_SELECT: 
                case ODA_DRAWENTIRE: 
                    hbmpPicture =(HBITMAP)SendMessage(lpdis->hwndItem, 
                        LB_GETITEMDATA, lpdis->itemID, (LPARAM) 0); 
 
                    hdcMem = CreateCompatibleDC(lpdis->hDC); 
                    hbmpOld = (HBITMAP)SelectObject(hdcMem, hbmpPicture); 
					/*if (lpdis->CtlID==IDC_LIST1)
					{*/
                    BitBlt(lpdis->hDC, 
                        lpdis->rcItem.left, lpdis->rcItem.top, 
                        lpdis->rcItem.right - lpdis->rcItem.left, 
                        lpdis->rcItem.bottom - lpdis->rcItem.top,
                        hdcMem, 0, 0, SRCCOPY); 
					/*}
					else
					{
                    BitBlt(lpdis->hDC, 
                        lpdis->rcItem.left, lpdis->rcItem.top, 
                        lpdis->rcItem.right - lpdis->rcItem.left, 
						dialog->getHeight(lpdis->itemID),
                        hdcMem, 0, 0, SRCCOPY); 
					}*/
                    SelectObject(hdcMem, hbmpOld); 
                    DeleteDC(hdcMem); 

                    if (lpdis->CtlID==IDC_LIST1&&(lpdis->itemState & ODS_SELECTED)) 
                    { 
                        rcBitmap.left = lpdis->rcItem.left; 
                        rcBitmap.top = lpdis->rcItem.top; 
						rcBitmap.right = lpdis->rcItem.right; 
						rcBitmap.bottom = lpdis->rcItem.bottom; 
                        DrawFocusRect(lpdis->hDC, &rcBitmap); 
                    } 
                    break; 
                case ODA_FOCUS: 
                    break; 
            } 
			break;
		case WM_COMMAND:
            switch (LOWORD(wParam)) 
            { 
				case IDC_OPEN:
					dialog->openFile();
					break;
				case IDC_EXPORT:
					dialog->exportRecord();
					break;
				case IDC_ABOUT:
					dialog->about();
					break;
				case IDC_EXIT:
					if (dialog->exit())
					{
						delete dialog;
						EndDialog(hDlg,TRUE);
					}
					break;
				case IDC_LIST1:
					if (GET_WM_COMMAND_CMD(wParam,lParam)==LBN_SELCHANGE)
					{
						dialog->setSecondList();
					}
					break;
                default: 
                    return FALSE; 
            } 
			break;
		default:
			return FALSE;
	}
	return TRUE;
}