#include "MainDialog.h"
#include "resource.h"
#include <windowsx.h>

#define BUFFER_SIZE 260
 //    
char *fileName="IDraw.adt";
 //   
char *filterString="IDraw file (IDraw*.adt)\000IDraw*.adt\000Adt-files (*.adt)\000*.adt\000All files (*.*)\000*.*\000";
 //   
char *filterString2="Images (*.bmp)\000*.bmp\000All files (*.*)\000*.*\000";
 //   ()

char *loadTitle="Load file";
//char *saveTitle="Save file";
//char *exitTitle="Confirm exit";
//char *viewTitle="Records view";
char *exportTitle="Export record";
//char *importTitle="Import record";
//char *deleteTitle="Delete record";


char *loadError="Load error";
char *invalidFormat="Invalid file format!";
char *accessDenied="Can't open file!";

//char *fileModifed="File is modifed.";
//char *confirmSave="Do you want to save current file?";
char *saveError="File write error!";
char *saveComplete="File saved successful!";

//char *confirmExit="File is modifed. Are you sure to exit?";

char *selectRecord="Select a record first.";
//char *splitFile="File is greater than 30kb. Split in a few part?";
char *exportError="Export error!";
//char *importError="Import error!";

char *operationComplete="Operation complete successful!";
//char *operationCanceled="Operation canceled!";

//char *viewError="You can view only text-record!";

MainDialog::MainDialog(HINSTANCE g_hinst, HWND hDlg)
:g_hinst(g_hinst),hDlg(hDlg),isFile(0),tempbmp(NULL)
{
	buffer=new char[BUFFER_SIZE];
	strcpy(buffer,fileName);
	iDir1=NULL;
	iDir2=NULL;
}

MainDialog::~MainDialog()
{
	delete [] buffer;
	if (iDir1)
		delete [] iDir1;
	if (iDir2)
		delete [] iDir2;
	if (tempbmp)
		delete tempbmp;
}

MainDialog::openFile()
{
	HANDLE openFile;
	OPENFILENAME ofn;

	//   
	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner         = hDlg;
	ofn.hInstance         = g_hinst;
	ofn.lpstrFilter       = filterString;
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 0;
	ofn.lpstrFile         = buffer;
	ofn.nMaxFile          = BUFFER_SIZE;
	ofn.lpstrFileTitle    = NULL;
	ofn.nMaxFileTitle     = 0;
	ofn.lpstrInitialDir   = iDir1;
	ofn.lpstrTitle        = loadTitle;
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lpstrDefExt       = "adt";
	ofn.lCustData         = NULL;
	ofn.lpfnHook 		  = NULL;
	ofn.lpTemplateName    = NULL;
	ofn.Flags             = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
	if (GetOpenFileName(&ofn))
	{
		openFile=CreateFile(buffer,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
		if (openFile==INVALID_HANDLE_VALUE)
		{
				MessageBox(hDlg,accessDenied,loadError,MB_OK | MB_ICONSTOP);
		}
		else
		{
			CloseHandle(openFile);
			if (file.load(buffer)) // 
			{
				isFile=1;
				setList();
				return 1;
			}
			else
			{
				MessageBox(hDlg,invalidFormat,loadError,MB_OK | MB_ICONSTOP);
			}
		}
	}
	return 0;
}

int MainDialog::exportRecord()
{
	char buffer2[BUFFER_SIZE];
	OPENFILENAME ofn;
	int cursel;
	HWND hList;

	hList=GetDlgItem(hDlg, IDC_LIST1);
	cursel=(int)SendMessage(hList,LB_GETCURSEL,0,0);

	if (!isFile||cursel==LB_ERR)
	{
		MessageBox(hDlg,selectRecord,exportTitle,MB_OK | MB_ICONINFORMATION);
		return 0;
	}

	buffer2[0]=0;
	if (iDir2==NULL && iDir1!=NULL)
	{
		iDir2=new char[strlen(iDir1)+1];
		strcpy(iDir2,iDir1);
	}
	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner         = hDlg;
	ofn.hInstance         = g_hinst;
	ofn.lpstrFilter		  = filterString2;
	ofn.lpstrDefExt       = "bmp";
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 0;
	ofn.lpstrFile         = buffer2;
	ofn.nMaxFile          = sizeof(buffer2);
	ofn.lpstrFileTitle    = NULL;
	ofn.nMaxFileTitle     = 0;
	ofn.lpstrInitialDir   = iDir2;
	ofn.lpstrTitle        = exportTitle;
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lCustData         = NULL;
	ofn.lpfnHook 		  = NULL;
	ofn.lpTemplateName    = NULL;
	ofn.Flags             = OFN_EXPLORER | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
	if (GetSaveFileName(&ofn))
	{				
		if (!file[cursel].saveBMP(buffer2))
		{
			MessageBox(hDlg,exportError,exportTitle,MB_OK | MB_ICONSTOP);			
			return 0;
		}	
		MessageBox(hDlg,operationComplete,exportTitle,MB_OK | MB_ICONINFORMATION);
		return 1;
	}
	return 0;
}

BOOL CALLBACK AboutProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_COMMAND:
			switch (GET_WM_COMMAND_ID(wParam,lParam))
			{
				case IDOK:
					EndDialog(hDlg,TRUE);
					break;
			}
		case WM_CLOSE:
			EndDialog(hDlg,TRUE);
			break;
		default:
			return (FALSE);
	}
	return (TRUE);
}

int MainDialog::about()
{
	DialogBox(g_hinst, MAKEINTRESOURCE(IDD_ABOUTBOX), hDlg, (DLGPROC)AboutProc);
	return 1;
}

int MainDialog::exit()
{
/*
    if (MessageBox(hDlg,confirmExit,exitTitle,MB_YESNO | MB_ICONQUESTION)==IDNO)
	{
		return 0;
	}
*/
	return 1;
}

void MainDialog::setList()
{
	HWND hList=GetDlgItem(hDlg, IDC_LIST1);
	SendMessage(hList,LB_RESETCONTENT,0,0);
	for(int i=0; i<file.size(); i++)
	{
		SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)(file[i].getBitmap())); 
	}
	if (file.size())
	{
		SetFocus(hList);
		SendMessage(hList,LB_SETCURSEL,0,0);
		setSecondList();
	}
}

int MainDialog::getCurrent()
{
	HWND hList=GetDlgItem(hDlg, IDC_LIST1);
	return (int)SendMessage(hList,LB_GETCURSEL,0,0);
}

void MainDialog::setSecondList()
{
	int cursel=getCurrent();
	HWND hList=GetDlgItem(hDlg, IDC_LIST2);
	
	SendMessage(hList,LB_RESETCONTENT,0,0);
	if (isFile&&cursel!=LB_ERR)
	{
		if (tempbmp!=NULL)
		{
			delete tempbmp;
			tempbmp=NULL;
		}
		tempbmp=file[cursel].createBitmap();
		for(int i=0; i<tempbmp->getCount(); i++)
			SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)(tempbmp->getBitmap(i))); 
	}
}

int MainDialog::getHeight(int num)
{
	return tempbmp->getHeight(num);
}